package com.brilliance.swift.mx2mt;

import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.XmlUtil;
import org.dom4j.Document;

import java.util.Map;

public abstract class AbstractMx2MtFieldsGenerate implements Mx2MtFieldsGenerate {

    protected Map<String, Object> map = null;

    protected void withMap(Map<String, Object> targetMap) {
        map = targetMap;
    }

    protected String getXmlNodeValue(String type, Document document, String path) {
        String parentPath = (String)map.get(type);
        if (StringUtil.isNotEmpty(parentPath)) {
            path = parentPath + "." + path;
        }
        return XmlUtil.getXmlNodeValue(document, path);
    }

    protected int getXmlNodeCounts(String type, Document document, String path) {
        String parentPath = (String)map.get(type);
        if (StringUtil.isNotEmpty(parentPath)) {
            path = parentPath + "." + path;
        }
        return XmlUtil.getChildrenCount(document, path, null);
    }

    protected String getBicCode(String type, Document document, String path) {
        //AnyBIC BICFI BICOrBEI BIC
        String bicCode = getXmlNodeValue(type, document, path+".AnyBIC");
        if (StringUtil.isEmpty(bicCode)) {
            bicCode = getXmlNodeValue(type, document, path+".BICFI");
        }
        if (StringUtil.isEmpty(bicCode)) {
            bicCode = getXmlNodeValue(type, document, path+".BICOrBEI");
        }
        if (StringUtil.isEmpty(bicCode)) {
            bicCode = getXmlNodeValue(type, document, path+".BIC");
        }
        return bicCode;
    }
}
