package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 若<Cd>节点值为“SDVA”，则取默认值“CRED”，否则直接取<Prtry>节点作为23B的值
 * <CdtTrfTxInf>[1]<PmtTpInf><SvcLvl><Cd>
 * <CdtTrfTxInf>[1]<PmtTpInf><SvcLvl><Prtry>
 */
public class Field23BGenerate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field23BGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field23B = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String cd = getXmlNodeValue(Mx2MtConstants.GRPHDR_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.PmtTpInf.SvcLvl.Cd");
            field23B = "SDVA".equals(cd) ? "CRED" : getXmlNodeValue(Mx2MtConstants.GRPHDR_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.PmtTpInf.SvcLvl.Prtry");
            map.put("field23B",field23B);
        }  catch(Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
