package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;

public class Field32AGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field32AGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String intrBkSttlmDtStr = "";
            String intrBkSttlmAmt = "";
            String intrBkSttlmccy = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String intrBkSttlmDtValue = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.IntrBkSttlmDt");
            if (StringUtil.isNotEmpty(intrBkSttlmDtValue)) {
                XMLGregorianCalendar intrBkSttlmDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(intrBkSttlmDtValue);
                intrBkSttlmDtStr = DateUtil.format(intrBkSttlmDt, "yyMMdd");
            }
            String amt = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.IntrBkSttlmAmt");
            String ccy = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.IntrBkSttlmAmt@Ccy");
            if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
                intrBkSttlmAmt = NumberUtil.formatAmt(new BigDecimal(amt), ccy);
                intrBkSttlmccy = ccy;
            }
            map.put("field32A", intrBkSttlmDtStr+intrBkSttlmccy+intrBkSttlmAmt);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}

