package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;

public class Field33BGenerate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field33BGenerate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field33B = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String amt = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.InstdAmt");
            String ccy = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.InstdAmt@Ccy");
            if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
                field33B = ccy + NumberUtil.formatAmt(new BigDecimal(amt), ccy);
            }
            map.put("field33B", field33B);
        } catch (Exception e) {
            throw new SwiftException(e.getMessage());
        }
    }
}

