package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

/**
 * //1，如果<BICFI>有值，则取值为“/INS/”+此节点的值
 *         //2，如果<Nm>有值，则取值为“/INS/”+此节点的值，超过35字节则将剩下内容用“//内容“的方式进行截取
 *         //3，若<InstrForCdtrAgt><InstrInf>有值，则转为“/ACC/此节点的值”，超过35字节则将剩下内容用“//内容“的方式进行截取
 *         //4，若<InstrForNxtAgt><InstrInf>有值，则转为“/REC/此节点的值”，超过35字节则将剩下内容用“//内容“的方式进行截取
 *         //<CdtTrfTxInf>[1]<PrvsInstgAgt1><FinInstnId><BICFI>
 *         //<CdtTrfTxInf>[1]<PrvsInstgAgt1><FinInstnId><Nm>
 *         //<CdtTrfTxInf>[1]<InstrForCdtrAgt><InstrInf>
 *         //<CdtTrfTxInf>[1]<InstrForNxtAgt><InstrInf>
 */
public class Field72Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field72Generate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            List<String> field72List = new ArrayList<>();
            List<String> field72TmpList = new ArrayList<>();
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String bicCode = getBicCode(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.PrvsInstgAgt1.FinInstnId");
            String name = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.PrvsInstgAgt1.FinInstnId.Nm");
            if (StringUtil.isNotEmpty(bicCode)) {
                bicCode = Mx2MtConstants.INS + bicCode;
                field72TmpList.addAll(StringUtil.outStringList(bicCode, 35, "//"));
            } else if (StringUtil.isNotEmpty(name)) {
                name = Mx2MtConstants.INS + name;
                field72TmpList.addAll(StringUtil.outStringList(name, 35, "//"));
            }
            String cdtrAgtInstrInf = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.InstrForCdtrAgt.InstrInf");
            if (StringUtil.isNotEmpty(cdtrAgtInstrInf)) {
                cdtrAgtInstrInf = Mx2MtConstants.ACC + cdtrAgtInstrInf;
                field72TmpList.addAll(StringUtil.outStringList(cdtrAgtInstrInf, 35, "//"));
            }
            String nxtAgtInstrInf = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.InstrForNxtAgt.InstrInf");
            if (StringUtil.isNotEmpty(nxtAgtInstrInf)) {
                nxtAgtInstrInf = Mx2MtConstants.REC + nxtAgtInstrInf;
                field72TmpList.addAll(StringUtil.outStringList(nxtAgtInstrInf, 35, "//"));
            }
            for (int i=0; i<field72TmpList.size(); i++) {
                if (i == 6) break;
                if (i == 0) {
                    field72List.add(":72:" + field72TmpList.get(i));
                } else {
                    field72List.add(field72TmpList.get(i));
                }
            }
            map.put("field72List", field72List);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}

