package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * // 1，取<RgltryRptg>[1]<Dtls>[1]<Inf>[1]作为第一行信息
 *         //2，取<RgltryRptg>[2]<Dtls>[1]<Inf>[1]作为第二行信息
 *         //3，取<RgltryRptg>[3]<Dtls>[1]<Inf>[1]作为第二行信息
 *         //<CdtTrfTxInf>[1]<RgltryRptg>[1]<Dtls>[1]<Inf>[1]
 */
public class Field77BGenerate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field77BGenerate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field77B = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            int size = getXmlNodeCounts(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.RgltryRptg");
            if (size > 0) {
                for (int i=0; i<size; i++) {
                    if (i == 3) break;
                    String dtlsInf = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.RgltryRptg("+i+").Dtls.Inf");
                    if (i == 0) {
                        dtlsInf = "/" + dtlsInf;
                    } else {
                        dtlsInf = "//" + dtlsInf;
                    }
                    if (dtlsInf.length() > 35) {
                        dtlsInf = dtlsInf.substring(0, 35);
                    }
                    if (i == 0) {
                        field77B += dtlsInf;
                    } else {
                        field77B += Mx2MtConstants.NEW_LINE + dtlsInf;
                    }
                }
            }
            map.put("field77B", field77B);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}

