package com.brilliance.swift.mx2mt.mt202cov202.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <CdtTrfTxInf>[1]<PmtId><EndToEndId>
 */
public class Field21Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field21Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String field21 = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.PmtId.EndToEndId");
            if (StringUtil.isEmpty(field21)) {
                field21 = "NONREF";
            }
            map.put("field21", field21);
        } catch(Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }

    }
}
