package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;

/**
 * 直接取此节点作为33B的货币和金额，XXX是货币
 * <CdtTrfTxInf>[1]<UndrlygCstmrCdtTrf><InstdAmt Ccy="xxx">
 */
public class FieldB33BGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(FieldB33BGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            Document document = (Document) map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String filed33B = "";
            String ccy = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.InstdAmt@Ccy");
            String amt = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.InstdAmt");
            if (StringUtil.isNotEmpty(ccy) && StringUtil.isNotEmpty(amt)) {
                String amtStr = NumberUtil.formatAmt(new BigDecimal(amt), ccy);
                filed33B = ccy+amtStr;
            }
            map.put("field33B", filed33B);
        } catch(Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}

