package com.brilliance.swift.mx2mt.mt202cov202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 取此节点按4*35的格式拆分，放入70栏位中(最多4行每行最多35个字符)
 * <CdtTrfTxInf>[1]<UndrlygCstmrCdtTrf><RmtInf><Ustrd>[1]
 */
public class FieldB70Generate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(FieldB70Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field70B = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            int ustrdCounts = getXmlNodeCounts(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Ustrd");
            if (ustrdCounts > 0) {
                String ustrd = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.UndrlygCstmrCdtTrf.RmtInf.Ustrd(0)");
                field70B = StringUtil.getStringByEnter(ustrd, 35, 4);
            }
            map.put("field70B", field70B);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
