package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <Ntfctn><Acct><Id><IBAN>
 * <Ntfctn><Acct><Id><<Othr><Id>
 */
public class Field25aGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field25aGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String iban = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String ban = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Acct.Id.IBAN");
            if (StringUtil.isNotEmpty(ban)) {
                iban = ban;
                map.put("field25a", iban);
            }else {
                String id = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Acct.Id.Othr.Id");
                if (StringUtil.isNotEmpty(id)) {
                    iban = id;
                    map.put("field25a", iban);
                }
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
