package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;

/**
 * <Ntfctn><Ntry><ValDt><Dt>
 * <Ntfctn><Ntry><Amt Ccy="XXX">
 */
public class Field32AGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field32AGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String dt = "";
            String amt = "";
            String ccy = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String dateStr = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.ValDt.Dt");
            if (StringUtil.isNotEmpty(dateStr)) {
                XMLGregorianCalendar XmlDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(dateStr);
                dt = DateUtil.format(XmlDt, "yyMMdd");
            }
            String amtStr = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.Amt");
            String ccyStr = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.Amt@Ccy");
            if (StringUtil.isNotEmpty(amtStr)&&StringUtil.isNotEmpty(ccyStr)) {
                amt = NumberUtil.formatAmt(new BigDecimal(amtStr), ccyStr);
                ccy = ccyStr;
                map.put("field32A",dt+ccy+amt);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }

}
