package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Field52aGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field52aGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String field52aOption = "";
            String field52a = "";
            String bicCode = getBicCode(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId");
            String memberId = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.ClrSysMmbId.MmbId");
            String name = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.Nm");
            memberId = "/" + memberId;
            if(memberId.length()>35)memberId = memberId.substring(0,35);
            if (StringUtil.isNotEmpty(bicCode)) {
                field52aOption = "A";
                if (StringUtil.isNotEmpty(memberId)) {
                    field52a = memberId + Mx2MtConstants.NEW_LINE + bicCode;
                } else {
                    field52a = bicCode;
                }
            }else if(StringUtil.isNotEmpty(name)){
                field52aOption = "D";
                if (StringUtil.isNotEmpty(memberId)) {
                    field52a = memberId + Mx2MtConstants.NEW_LINE + name;
                }
                int adrLineCount = getXmlNodeCounts(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.PstlAdr.AdrLine");
                if(adrLineCount>0){
                    for (int i=0; i<adrLineCount; i++) {
                        if (i == 3) {
                            break;
                        }
                        String adrLine = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.PstlAdr.AdrLine("+i+")");
                        if (adrLine.length() > 35) adrLine = adrLine.substring(0, 35);
                        field52a += Mx2MtConstants.NEW_LINE + adrLine;
                    }
                }
            }
            if (StringUtil.isNotEmpty(field52aOption) && StringUtil.isNotEmpty(field52a)) {
                map.put("field52aOption", field52aOption);
                map.put("field52a", field52a);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
