package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Field56aGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field56aGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        String mtType = (String)map.get(Mx2MtConstants.MT_TYPE);
        if (!Mx2MtConstants.MT_TYPE_910.equals(mtType)) {
            return;
        }
        try {
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String field56aOption = "";
            String field56a = "";
            String bicCode = getBicCode(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.IntrmyAgt1.FinInstnId");
            String memberId = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.IntrmyAgt1.FinInstnId.ClrSysMmbId.MmbId");
            String name = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.IntrmyAgt1.FinInstnId.Nm");
            memberId = "/" + memberId;
            if(memberId.length()>35)memberId = memberId.substring(0,35);
            if (StringUtil.isNotEmpty(bicCode)) {
                field56aOption = "A";
                if (StringUtil.isNotEmpty(memberId)) {
                    field56a = memberId + Mx2MtConstants.NEW_LINE + bicCode;
                } else {
                    field56a = bicCode;
                }
            }else if(StringUtil.isNotEmpty(name)){
                field56aOption = "D";
                if (StringUtil.isNotEmpty(memberId)) {
                    field56a = memberId + Mx2MtConstants.NEW_LINE + name;;
                }
                int adrLineCount = getXmlNodeCounts(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.IntrmyAgt1.FinInstnId.PstlAdr.AdrLine");
                if(adrLineCount>0){
                    for (int i=0; i<adrLineCount; i++) {
                        if (i == 3) {
                            break;
                        }
                        String adrLine = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.IntrmyAgt1.FinInstnId.PstlAdr.AdrLine("+i+")");
                        if (adrLine.length() > 35) adrLine = adrLine.substring(0, 35);
                        field56a += Mx2MtConstants.NEW_LINE + adrLine;
                    }
                }
            }
            if (StringUtil.isNotEmpty(field56aOption) && StringUtil.isNotEmpty(field56a)) {
                map.put("field56aOption", field56aOption);
                map.put("field56a", field56a);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
