package com.brilliance.swift.mx2mt.mt940950.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtFieldsGenerate;
import com.brilliance.swift.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <GrpHdr><MsgPgntn><PgNb>
 * <Stmt><ElctrncSeqNb>
 */
public class Field28CGenerate extends AbstractMx2MtFieldsGenerate{

    private static final Logger logger = LoggerFactory.getLogger(Field28CGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException{
        try {
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String elctrncSeqNb = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "Stmt.ElctrncSeqNb");
            String pgNb = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "GrpHdr.MsgPgntn.PgNb");
            if(StringUtil.isEmpty(elctrncSeqNb)&&StringUtil.isEmpty(pgNb)){
                throw new SwiftException("ERROR", "Convert MT950 field28C is required!");
            }else {
                if(StringUtil.isEmpty(elctrncSeqNb)){
                    map.put("field28C", pgNb);
                }else if(StringUtil.isEmpty(pgNb)){
                    map.put("field28C",elctrncSeqNb);
                }else {
                    map.put("field28C", elctrncSeqNb + "/" + pgNb);
                }
            }
        } catch(Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
